import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;

public class DamasCliente extends JFrame implements Runnable
{
    private final int BRANCA = 0;
    private final int PRETA  = 1;
    private JDesktopPane desktop;
    private ImageIcon pretas;
    private ImageIcon brancas;
    private ImageIcon damaBranca;
    private ImageIcon damaPreta;
    protected JTextArea areaMensagens;
    private JButton btSair;
    private JButton btLimpar;
    protected JButton pecas[][] = new JButton[8][8];
    private JPanel tabuleiro;
    private JPanel status;
    private JLabel labelBrancas = new JLabel("12");
    private JLabel labelPretas  = new JLabel("12");
    private JLabel avisoVez;
    protected JTextField chat;
	private Font fonteArial10;
    private Point ptOrigem = new Point();
    private Point ptDestino = new Point();
    private int ID;
    private int pecasBranca = 12;
    private int pecasPreta = 12;
    private boolean setandoDestino = false;

    String ipServidor;
    private Socket conexao;
    private ObjectInputStream in;
    private ObjectOutputStream out;
    private Thread thread;
    private boolean minhaVez = false;
    
    public void run()
    {
        while (true)
        {
            try
            {
            	String s = (String)(in.readObject());
                analisadorMovimento(s);
            }
            catch (Exception ioex){ioex.printStackTrace();}
        }
    }

    private void analisadorMovimento(String s)
    {
        int mudarVez, peca, lo, co, ld, cd, x_tmp, y_tmp;
        x_tmp = y_tmp = 0;
        boolean comeu = false; 
        System.out.println(s);
        String cmd = s.substring(0,3);
        
        if(cmd.equals("LAB"))
        {
            StringTokenizer token = new StringTokenizer(s.substring(4, s.length()), " ");
            String brancas = token.nextToken();
            String pretas = token.nextToken();

            labelBrancas.setText(brancas);
            labelPretas.setText(pretas);
        }
        else if (cmd.equals("NOV"))
        {
            int vez = Integer.parseInt(s.substring(4,5));

            if (vez == ID)
            {
                minhaVez = true;
                avisoVez.setText("Novo jogo. Voc est com a VEZ");
                avisoVez.setForeground(new Color(17, 126, 60));
            }
            else
            {
                minhaVez = false;
                avisoVez.setText("Novo jogo. Adversrio tem a VEZ");
                avisoVez.setForeground(Color.red);
            }

            labelBrancas.setText("12");
            labelPretas.setText("12");
            setandoDestino = false;
            setEstadoInicial();
        }
        else if(cmd.equals("FIM"))
        {
            StringTokenizer token = new StringTokenizer(s.substring(4, s.length()), " ");
            String vencedor = token.nextToken();
            
            if(vencedor.equals("1"))
            {
                if(ID == BRANCA)
                    JOptionPane.showMessageDialog(this, "TREINE MAIS! Seu adversrio venceu a partida", 
                                "Trmino do jogo", JOptionPane.INFORMATION_MESSAGE);
                else
                    JOptionPane.showMessageDialog(this, "PARABNS! voc venceu a partida", 
                                "Trmino do jogo", JOptionPane.INFORMATION_MESSAGE);
            }
            else
            {
                if(ID == BRANCA)
                    JOptionPane.showMessageDialog(this, "PARABNS! voc venceu a partida", 
                                "Trmino do jogo", JOptionPane.INFORMATION_MESSAGE);            
                else
                    JOptionPane.showMessageDialog(this, "TREINE MAIS! Seu adversrio venceu a partida", 
                                "Trmino do jogo", JOptionPane.INFORMATION_MESSAGE);
            }        
        }
        else if (cmd.equals("REC"))
        {
            setandoDestino = false;
        }
        else if(cmd.equals("INI"))
        {
            int vez = Integer.parseInt(s.substring(4, 5));
            
            if (vez == ID)
            {
                minhaVez = true;
                avisoVez.setForeground(new Color(17, 126, 60));
            }
            else
                avisoVez.setForeground(Color.red);

            avisoVez.setText(s.substring(6, s.length()));
        }
        else if(cmd.equals("MSG"))
        {
            System.out.println("Chegou no CLIENTE a msg = \"" + s + "\"");
            if (areaMensagens != null)
                areaMensagens.append("\n" + s.substring(4, s.length()));
        }
        else
        {
            StringTokenizer tokens = new StringTokenizer(s.substring(4,s.length()));
            peca = Integer.parseInt(tokens.nextToken());
            lo = Integer.parseInt(tokens.nextToken());
            co = Integer.parseInt(tokens.nextToken());
            ld = Integer.parseInt(tokens.nextToken());
            cd = Integer.parseInt(tokens.nextToken());

            if (s.length() == 19)
            {
                comeu = true;
                x_tmp = Integer.parseInt(tokens.nextToken());
                y_tmp = Integer.parseInt(tokens.nextToken());
            }

            mudarVez = Integer.parseInt(tokens.nextToken());

            if (comeu)
            {
                pecas[x_tmp][y_tmp].setIcon(null);
                comeu = false;
            }
        
            if (cmd.equals("ACP"))
            {
                pecas[lo][co].setIcon(null);
                setandoDestino = false;

                if (mudarVez == 1)
                {
                    minhaVez = false;
                    avisoVez.setText("Adversrio tem a VEZ");
                    avisoVez.setForeground(Color.red);
                }
                else
                {
                    minhaVez = true;
                    avisoVez.setText("Voc est com a VEZ");
                    avisoVez.setForeground(new Color(17, 126, 60));
                }

                if (ID == BRANCA)
                {
                    if (peca == BRANCA)
                        pecas[ld][cd].setIcon(brancas);
                    else
                        pecas[ld][cd].setIcon(damaBranca);
                }
                else
                {
                    if (peca == PRETA)
                        pecas[ld][cd].setIcon(pretas);                 
                    else
                        pecas[ld][cd].setIcon(damaPreta);                 
                }
            }
            else if(cmd.equals("ATZ"))
            {
                pecas[lo][co].setIcon(null);

                if (mudarVez == 1)
                {
                    minhaVez = true;
                    avisoVez.setText("Voc est com a VEZ");                
                    avisoVez.setForeground(new Color(17, 126, 60));
                }
                else
                {
                    avisoVez.setText("Adversrio tem a VEZ");
                    minhaVez = false;
                    avisoVez.setForeground(Color.red);
                }

                if (ID == BRANCA)
                {
                    if (peca == PRETA)
                        pecas[ld][cd].setIcon(pretas);
                    else
                        pecas[ld][cd].setIcon(damaPreta);
                }
                else
                {
                    if (peca == BRANCA)
                        pecas[ld][cd].setIcon(brancas);                 
                    else
                        pecas[ld][cd].setIcon(damaBranca);
                }
            }
        }
    }

    public void start()
    {
        try 
        {
            conexao = new Socket(InetAddress.getByName(ipServidor), 5000 );
            out = new ObjectOutputStream(conexao.getOutputStream() );
            out.flush();
            in = new ObjectInputStream(conexao.getInputStream() );
        }
        catch ( IOException e ) {e.printStackTrace();}

        try
        {
            String s = (String)(in.readObject());
            System.out.println("Meu ID eh: " + s);
            ID = Integer.parseInt(s.substring(0,1));
            
            if (ID == BRANCA)
            {
                avisoVez.setText("Voc tem as peas BRANCAS");
                avisoVez.setForeground(new Color(17, 126, 60));
            }
            else
            {
                avisoVez.setText("Voc tem as peas PRETAS");
                avisoVez.setForeground(new Color(17, 126, 60));
            }
        }
        catch (Exception e){System.out.println("Erro ao conectar com o servidor!");}

        thread = new Thread( this );
        thread.start();
    }

    public void enviarMensagem(String s)
    {
        try
        {
            String msgTmp = "-> " + s;
            String msg = "MSG " + ID + " " + msgTmp;
            msgTmp = "<- " + s;
            areaMensagens.append("\n" + msgTmp);
            out.writeObject(msg);
        }
        catch (IOException ioex){ioex.printStackTrace();}
    }
    
    public DamasCliente(String ip)
    {
        super("Bem-vindo ao Damas-P2P!");
        fonteArial10 = new Font("Arial", Font.PLAIN, 10);
        Dimension tamanhoTela = Toolkit.getDefaultToolkit().getScreenSize();
        int origemX = tamanhoTela.width - 800;
        int origemY = tamanhoTela.height - 600;

        if (origemX > 0 && origemY > 0)
        {
            origemX /= 2;
            origemY /= 2;
        }

        setBounds(origemX, origemY, tamanhoTela.width, tamanhoTela.height);
        desktop = new JDesktopPane();
        desktop.setBackground(Color.white);

        setContentPane(desktop);
		Container c = getContentPane();
     
        c.setLayout(null);
        Insets insets = c.getInsets();
        setJMenuBar(criarMenus());
        
        ipServidor = ip;
        criarTabuleiro();
        criarStatus();
        
        tabuleiro.setBounds(insets.left, insets.top, 540, 540);
        status.setBounds(540, insets.top, 250, 530);

        c.add(tabuleiro);
        c.add(status);
        
        setEstadoInicial();

        setResizable(true);
        setSize(800, 600);
        show();
    }

    private Border criarBorda(String titulo)
	{
		Border bd = BorderFactory.createTitledBorder(
					BorderFactory.createLineBorder(Color.black),
					titulo, TitledBorder.LEFT, 
					TitledBorder.TOP, fonteArial10);

		return bd;
	}

    private void criarStatus()
    {
        // 250 largura, 550 altura
        status = new JPanel();
        status.setBackground(Color.white);
        status.setLayout(null);
        Border bd = BorderFactory.createEmptyBorder(5,5,5,5);
        status.setBorder(bd);

        JPanel p1 = adicionarPlacar();
        JPanel p2 = adicionarMensagens();
        JPanel p3 = adicionarChat();
            
        p1.setBounds(0,   0, 245, 125);
        p2.setBounds(0, 130, 245, 185);
        p3.setBounds(0, 320, 245, 210);

        status.add(p1);
        status.add(p2);
        status.add(p3);
    }

    private JPanel adicionarPlacar()
    {
        JPanel p = new JPanel();
        p.setBorder(criarBorda("PEAS DISPONVEIS"));
        p.setBackground(Color.white);
        p.setLayout(new GridLayout(1,2));
        labelBrancas.setIcon(brancas);
        labelPretas.setIcon(pretas);
        labelBrancas.setHorizontalAlignment(JLabel.CENTER);
        labelPretas.setHorizontalAlignment(JLabel.CENTER);
        p.add(labelBrancas);
        p.add(labelPretas);
        return p;
    }

    private JPanel adicionarMensagens()
    {
        JPanel p = new JPanel();
        p.setBorder(criarBorda("MENSAGENS"));
        p.setBackground(Color.white);
        p.setLayout(new GridLayout(1,1));

        areaMensagens = new JTextArea("Histrico de mensagens");
        areaMensagens.append("\n");
        areaMensagens.setFont(fonteArial10);
        JScrollPane scroll = new JScrollPane(areaMensagens);
        scroll.setWheelScrollingEnabled(true);
        scroll.setBorder(BorderFactory.createEmptyBorder(0,0,0,0));
        areaMensagens.setEditable(false);
        p.add(scroll);
        return p;
    }

    private JPanel adicionarChat()
    {
        JPanel p = new JPanel();
        p.setBorder(criarBorda("CHAT ON-LINE"));
        p.setBackground(Color.white);
        p.setLayout(null);

        JPanel botoes = new JPanel();
        botoes.setLayout(new GridLayout(1,2));
        botoes.setBackground(Color.white);
        botoes.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        btSair = new JButton("Sair");
        btLimpar = new JButton("Limpar");
        botoes.add(btLimpar);
        botoes.add(btSair);

        ImageIcon logoDamas = new ImageIcon(this.getClass().getResource("/pics/damasP2P.png"));
        chat = new JTextField("Tecle com seu oponente");
        JLabel logo = new JLabel(logoDamas);
        avisoVez = new JLabel("", JLabel.CENTER);

        chat.setBorder(criarBorda(""));
        logo.setBounds    (  5,  15, 235,  90);
        avisoVez.setBounds( 10,  95, 225,  30);
        chat.setBounds    ( 10, 130, 225,  30);
        botoes.setBounds  ( 10, 165, 225,  30);

        btSair.addActionListener(new HandlerCliente(DamasCliente.this, this));
        btLimpar.addActionListener(new HandlerCliente(DamasCliente.this, this));
        chat.addActionListener(new HandlerCliente(DamasCliente.this, this));
        
        p.add(logo);
        p.add(avisoVez);
        p.add(chat);
        p.add(botoes);
        return p;
    }
    
    private void criarTabuleiro()
    {
        pretas = new ImageIcon(this.getClass().getResource("/pics/pretas.png"));
        brancas = new ImageIcon(this.getClass().getResource("/pics/brancas.png"));
        damaBranca = new ImageIcon(this.getClass().getResource("/pics/damaBranca.png"));
        damaPreta = new ImageIcon(this.getClass().getResource("/pics/damaPreta.png"));

        tabuleiro = new JPanel();
        tabuleiro.setBackground(Color.white);
        tabuleiro.setLayout(new GridLayout(8,8));
        tabuleiro.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

        for(int i = 0; i < 8; i++)   
        {

            for(int j = 0; j < 8; j++)
            {
                pecas[i][j] = new JButton();

                if (i%2 == 0)
                {
                    if (j%2 == 0)
                        pecas[i][j].setBackground(Color.white);
                    else
                        pecas[i][j].setBackground(Color.black);
                }
                else
                {
                    if (j%2 == 0)
                        pecas[i][j].setBackground(Color.black);
                    else
                        pecas[i][j].setBackground(Color.white);
                }

                pecas[i][j].setBorder(BorderFactory.createLineBorder(Color.black));
                tabuleiro.add(pecas[i][j]);
           }
        }
        adicionarListeners();
    }

    public void jogarNovamente()
    {
        String msg;
        try
        {
            msg = "NOV " + ID;
            out.writeObject(msg);
        }
        catch (Exception e)
        {
            System.out.println("Nao eh possivel iniciar novo jogo");
        }
    }

    public void setPonto(Point p)
    {
        if (minhaVez)
        {
            int x, y;
            x = (int)p.getX();
            y = (int)p.getY();

            if (!setandoDestino)
            {
                ptOrigem.setLocation(p);
                setandoDestino = true;
            }
            else
            {
                ptDestino.setLocation(p);
                movimentar(ptOrigem, ptDestino);
                // setandoDestino = false;
            }
        }
    }

    private void movimentar(Point origem, Point destino)
    {
        // Enviar pontos ao socket
        String s = "";
        try
        {
            s = ID + " " + (int)origem.getX() + " " + (int)origem.getY() + " " +
                (int)destino.getX() + " " + (int)destino.getY();
            out.writeObject(s);
        }
        catch (Exception e) {} 
    }

    private void setEstadoInicial()
    {
        // Colocando as peas pretas
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 8; j++)
                if (pecas[i][j].getBackground() == Color.black)
                {
                    pecas[i][j].setIcon(pretas);        
                }
        }

        for (int i = 3; i < 5; i++)
        {
            for (int j = 0; j < 8; j++)
                if (pecas[i][j].getBackground() == Color.black)
                {
                    pecas[i][j].setIcon(null);        
                }
        }

        // Colocando as peas brancas
        for (int i = 5; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
                if (pecas[i][j].getBackground() == Color.black)
                {
                    pecas[i][j].setIcon(brancas);        
                }
        }
    }

    private void adicionarListeners()
    {
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (pecas[i][j].getBackground() == Color.black)
                    pecas[i][j].addActionListener(new HandlerPecas(this));
            }
        }
    }

    private JMenuBar criarMenus()
    {
		Color c = new Color(205, 200, 200);

		// Declarando a barra de menus
		Font			fonteArial10;
		JMenuBar		bar;
		JMenu			menuArquivo;
        JMenu           menuAjuda;
		JMenuItem		itemSobre;
        JMenuItem		itemSair;
        JMenuItem       itemNovoJogo;

		// Criando a barra de menus e
        // Instanciando os objetos do menu
		bar				= new JMenuBar();
        menuArquivo		= new JMenu("ARQUIVO");
        menuAjuda       = new JMenu("AJUDA");
		itemSobre		= new JMenuItem("Sobre o Desenvolvimento");
        itemSair		= new JMenuItem("Sair");
        itemNovoJogo    = new JMenuItem("Novo jogo");
		fonteArial10    = new Font("Arial", Font.BOLD, 10);
		
		// Escolhendo o mnemonico para a opo
        menuArquivo.setMnemonic('A');
        menuAjuda.setMnemonic('J');
        itemSobre.setMnemonic('S');
        itemSair.setMnemonic('S');
        itemNovoJogo.setMnemonic('N');

		// Tooltips
		itemSobre.setToolTipText("Informaes sobre os desenvolvedores");
		itemSair.setToolTipText("Efetua a sada do sistema");
        itemNovoJogo.setToolTipText("Iniciar uma nova partida");
		menuAjuda.setToolTipText("Ajuda do Damas P2P");
        menuArquivo.setToolTipText("Opes de jogo");

		ImageIcon iconArquivo = new ImageIcon(this.getClass().getResource("/pics/arquivo.png"));
		ImageIcon iconSobre	= new ImageIcon(this.getClass().getResource("/pics/sobre.png"));
		ImageIcon iconSair = new ImageIcon(this.getClass().getResource("/pics/sair.png"));
        ImageIcon iconAjuda = new ImageIcon(this.getClass().getResource("/pics/ajuda.png"));
        ImageIcon iconNovoJogo = new ImageIcon(this.getClass().getResource("/pics/novoJogo.png"));
        
        // Setando os icones
		menuArquivo.setIcon(iconArquivo);
        menuAjuda.setIcon(iconAjuda);
		itemSair.setIcon(iconSair);
		itemSobre.setIcon(iconSobre);
        itemNovoJogo.setIcon(iconNovoJogo);
		
		// Setando o fundo de cada componente
		bar.setBackground(c);
		menuArquivo.setBackground(c);
        menuAjuda.setBackground(c);
		itemSair.setBackground(c);
		itemSobre.setBackground(c);
        itemNovoJogo.setBackground(c);

        itemSair.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
		itemSobre.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.CTRL_MASK));
        itemNovoJogo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));

   		// Listeners para as aes
		itemSobre.addActionListener(new HandlerCliente(DamasCliente.this, this));
        itemSair.addActionListener(new HandlerCliente(DamasCliente.this, this));
		menuAjuda.addActionListener(new HandlerCliente(DamasCliente.this, this));
		itemNovoJogo.addActionListener(new HandlerCliente(DamasCliente.this, this));

		// Adicionando fisicamente aos menus
        menuArquivo.add(itemNovoJogo);
        menuArquivo.addSeparator();
        menuArquivo.add(itemSair);
   		menuAjuda.add(itemSobre);

		// Adicionando fisicamente a barra de menus
		bar.add(menuArquivo);
        bar.add(menuAjuda);

        menuArquivo.setFont(fonteArial10);
        menuAjuda.setFont(fonteArial10);
        itemSair.setFont(fonteArial10);
		itemSobre.setFont(fonteArial10);
        itemNovoJogo.setFont(fonteArial10);

        return bar;
    }

    // Mtodo principal que chama o programa  execuo
    public static void main(String args[])
    {
        try 
		{
            UIManager.setLookAndFeel(
                UIManager.getCrossPlatformLookAndFeelClassName());
        } 
		catch (Exception e) { }
		
        SplashScreen splash = new SplashScreen();
        
        final DamasCliente cliente;

        try
        {
            if (args.length == 1)
                cliente = new DamasCliente(args[0]);
            else 
                cliente = new DamasCliente("127.0.0.1");

            cliente.start();
            cliente.addWindowListener( new WindowAdapter()
            {
                public void windowClosing(WindowEvent e)
                {
                    JOptionPane.showMessageDialog(cliente, "Obrigado por jogar!",
                            "Saindo do Damas-P2P", JOptionPane.INFORMATION_MESSAGE);
                    System.exit(0);
                }
            }); 

            // Exibindo o frame na tela
	    	cliente.setVisible(true);
            splash.hide();
        }
        catch (Exception e)
        {
            System.out.println("Nao foi possivel conectar ao servidor");
        }
    }
}

class SplashScreen extends JWindow
{
    public SplashScreen()
    {
        Dimension tamanhoTela = Toolkit.getDefaultToolkit().getScreenSize();
        JLabel labelSplash = new JLabel(new ImageIcon(this.getClass().getResource("/pics/splash.png")));
        int origemX = tamanhoTela.width - 560;
        int origemY = tamanhoTela.height - 300;
        setBounds(origemX / 2, origemY/2, tamanhoTela.width, tamanhoTela.height);        
        setSize(560, 300);
        Container c = getContentPane();
        c.setLayout(new BorderLayout());
        c.add(labelSplash, BorderLayout.CENTER);
        show();
    }
};

