import java.net.*;
import java.io.*;
import java.awt.*;

public class DamasServidor
{
    private int statusPecas[][] = new int[8][8];
    private final int BRANCA = 0;
    private final int PRETA  = 1;
    private final int DAMA_BRANCA  = 2;
    private final int DAMA_PRETA   = 3;
    private final int LIVRE   = 4;
    private final int INUTIL = 5;
    int VEZ;
    private int pecasBranca = 12;
    private int pecasPreta = 12;

    public Jogador jogadores[];
    private ServerSocket server;

    // Variaveis para controle e formacao do pacote de envio
    int x_tmp; 
    int y_tmp;
    boolean comeu;
    boolean movimentoCompleto = false;
   
    public DamasServidor()
    {
        System.out.println("DAMAS P2P - Servidor");

        jogadores = new Jogador[ 2 ];

        try 
        {
            server = new ServerSocket(5000, 2);
            setEstadoInicial();
            System.out.println("Servidor pronto e esperando conexoes");
        }
        catch( IOException e ) 
        {
            e.printStackTrace();
        }
    }

    public void validar(int jogador, String s)
    {
        int xy[] = new int[5]; 
        String aux = "";

        System.out.println(jogador + " " + s);

        while (jogador != VEZ)
        {
            try
            {
                wait();
            }
            catch (Exception e){}
        }

        int j = 0;
        for (int i = 0; i < s.length(); i+=2)
        {
            aux = s.charAt(i) + "";
            xy[j++] = Integer.parseInt(aux);
        }

        String cmd;
        comeu = false;
        x_tmp = y_tmp = 0;
        int peca;

        try
        {
            if (VEZ == BRANCA)
            {
                if (movimentar(xy[1], xy[2], xy[3], xy[4]))
                {
                    if (!comeu)
                        cmd = xy[1] + " " + xy[2] + " " + xy[3] + " " + xy[4];
                    else
                    {
                        cmd = xy[1] + " " + xy[2] + " " + xy[3] + " " + xy[4] + " " +
                              x_tmp + " " + y_tmp;

                        jogadores[BRANCA].output.writeObject("LAB " + pecasBranca + " " + pecasPreta);
                        jogadores[PRETA].output.writeObject("LAB " + pecasBranca + " " + pecasPreta);
                    }

                    if (statusPecas[xy[3]][xy[4]] == DAMA_BRANCA)
                        peca = DAMA_BRANCA;
                    else
                        peca = BRANCA;

                    if (movimentoCompleto)
                        cmd += " " + 1;
                    else
                        cmd += " " + 0;

                    jogadores[BRANCA].output.writeObject("ACP " + peca + " " + cmd);
                    jogadores[PRETA].output.writeObject("ATZ " + peca + " " + cmd);
                }
                else
                    jogadores[BRANCA].output.writeObject("REC");
            }
            else if (VEZ == PRETA)
            {
                if (movimentar(xy[1], xy[2], xy[3], xy[4]))
                {
                    if (!comeu)
                        cmd = xy[1] + " " + xy[2] + " " + xy[3] + " " + xy[4];
                    else
                    {
                        cmd = xy[1] + " " + xy[2] + " " + xy[3] + " " + xy[4] + " " +
                              x_tmp + " " + y_tmp;
                        jogadores[BRANCA].output.writeObject("LAB " + pecasBranca + " " + pecasPreta);
                        jogadores[PRETA].output.writeObject("LAB " + pecasBranca + " " + pecasPreta);
                    }

                    if (statusPecas[xy[3]][xy[4]] == DAMA_PRETA)
                        peca = DAMA_PRETA;
                    else
                        peca = PRETA;

                    if (movimentoCompleto)
                        cmd += " " + 1;
                    else
                        cmd += " " + 0;

                    jogadores[PRETA].output.writeObject("ACP " + peca + " " + cmd);
                    jogadores[BRANCA].output.writeObject("ATZ " + peca + " " + cmd);
                }
                else
                {
                    jogadores[PRETA].output.writeObject("REC");
                }
            }
        }
        catch (Exception e){System.err.println("Erro em VALIDAR");}
        
        synchronized (jogadores[VEZ]) 
        {
            try
            {
                jogadores[ VEZ ].suspenso = false;   
                jogadores[ VEZ ].notify();
            }
            catch (Exception e){System.err.println("ERRO mudando de jogador");}
        }
    }
   
    public void executar()
    {
        try 
        {
            jogadores[ 0 ] = new Jogador( server.accept(), this, BRANCA );
            jogadores[ 0 ].start();
            System.out.println("Jogador 1 criado");
            jogadores[ 1 ] = new Jogador( server.accept(), this, PRETA );
            jogadores[ 1 ].start();
            VEZ = (int)(Math.random() * 2);
            System.out.println("Jogador 2 criado");
        }
        catch( IOException e ) 
        {
            e.printStackTrace();
        }
 
        if (VEZ == BRANCA)
        {
            synchronized ( jogadores[ BRANCA ] ) 
            {
                jogadores[ BRANCA ].suspenso = false;   
                jogadores[ BRANCA ].notify();
            }
        }
        else
        {
            synchronized ( jogadores[ PRETA ] ) 
            {
                jogadores[ PRETA ].suspenso = false;   
                jogadores[ PRETA ].notify();
            }
        }
        
        try 
        {
            if (VEZ == BRANCA)
            {
                jogadores[0].output.writeObject("INI " + VEZ + " Voc est com a VEZ");
                jogadores[1].output.writeObject("INI " + VEZ + " Adversrio tem a VEZ");            
            }
            else
            {
                jogadores[0].output.writeObject("INI " + VEZ + " Adversrio tem a VEZ");            
                jogadores[1].output.writeObject("INI " + VEZ + " Voc est com a VEZ");
            }
        }
        catch(Exception e) {}
   }
   
    public static void main( String args[] )
    {
        DamasServidor game = new DamasServidor();
        game.executar();
    }

    ////////////////////////// FUNCOES DO JOGO ///////////////////////////
    private boolean damaAindaPodeComer(int lo, int co, int PECA, int DAMA)
    {
        int x,y;
        x = lo; y = co;

        try
        {
            do
            {
                x++; y--;
            } while (statusPecas[x][y] == LIVRE && x < 7 && y > 0);

            if (statusPecas[x][y] == PECA || statusPecas[x][y] == DAMA)
            {
                x++; y--;
                if (statusPecas[x][y] == LIVRE)
                    return true;
            }
        } catch (Exception e){}

        x = lo; y = co;
        try
        {        
            do
            {
                x--; y++;
            } while (statusPecas[x][y] == LIVRE && x > 0  && y < 7);

            if (statusPecas[x][y] == PECA || statusPecas[x][y] == DAMA)
            {
                x--; y++;
                if(statusPecas[x][y] == LIVRE)
                    return true;
            }
        } catch (Exception e){}

        x = lo; y = co;
        try
        {
            do
            {
                x++; y++;
            } while (statusPecas[x][y] == LIVRE && x < 7 && y < 7);

            if (statusPecas[x][y] == PECA || statusPecas[x][y] == DAMA)
            {
                x++; y++;
                if (statusPecas[x][y] == LIVRE)
                    return true;
            }
        } catch (Exception e){}

        x = lo; y = co;
        try
        {
            do
            {
                x--; y--;
            } while (statusPecas[x][y] == LIVRE && x > 0 && y > 0);

            if (statusPecas[x][y] == PECA || statusPecas[x][y] == DAMA)
            {
                x--; y--;
                if (statusPecas[x][y] == LIVRE)
                    return true;
            }
        } catch (Exception e){}
        return false;
    }

    private boolean comerPeca(int lo, int co, int ld, int cd)
    {
        if (lo >= 0 && lo < 8 && co >= 0 && co < 8 &&
            ld >= 0 && ld < 8 && cd >= 0 && cd < 8)
        {
            if (statusPecas[lo][co] == DAMA_BRANCA)
            {
                Point p = espacoLivre(lo, co, ld, cd);
                
                if (p == null)
                {
                    comeu = false;
                    return false;
                }
                else
                {
                    int x = (int)p.getX();
                    int y = (int)p.getY();

                    if ((statusPecas[x][y] == PRETA || statusPecas[x][y] == DAMA_PRETA) &&
                        espacoLivre(x,y,ld,cd) == null)
                    {
                        statusPecas[x][y] = LIVRE;
                        statusPecas[lo][co] = LIVRE;

                        statusPecas[ld][cd] = DAMA_BRANCA;
                        pecasPreta--;
                        x_tmp = x;
                        y_tmp = y;
                        comeu = true;
                        return true;
                    }
                }
            }
            else if (statusPecas[lo][co] == DAMA_PRETA)
            {
                Point p = espacoLivre(lo, co, ld, cd);
                
                if (p == null)
                {
                    comeu = false;
                    return false;
                }
                else
                {
                    int x = (int)p.getX();
                    int y = (int)p.getY();

                    if ((statusPecas[x][y] == BRANCA || statusPecas[x][y] == DAMA_BRANCA) &&
                        espacoLivre(x,y,ld,cd) == null)
                    {
                        statusPecas[x][y] = LIVRE;
                        statusPecas[lo][co] = LIVRE;
                        statusPecas[ld][cd] = DAMA_PRETA;
                        pecasBranca--;
                        x_tmp = x;
                        y_tmp = y;
                        comeu = true;
                        return true;
                    }
                }
            }
            else if (aindaPodeComer(lo, co, ld, cd))
            {
                int lold = (int)((lo + ld)/2);
                int cocd = (int)((co + cd)/2);
                statusPecas[lold][cocd] = LIVRE;
                x_tmp = lold;
                y_tmp = cocd;
                comeu = true;
                return true;
            }
        }
        return false;
    }

    private boolean aindaPodeComer(int lo, int co, int ld, int cd)
    {
        if (lo >= 0 && lo < 8 && co >= 0 && co < 8 &&
            ld >= 0 && ld < 8 && cd >= 0 && cd < 8)
        {
            int lold, cocd;
            int tmpx, tmpy;
            tmpx = (lo + ld);
            tmpy = (co + cd);
            
            if (tmpx % 2 == 0 && tmpy % 2 == 0)
            {
            
            lold = (int)tmpx/2;
            cocd = (int)tmpy/2;
                
                if (statusPecas[ld][cd] == LIVRE)
                {
                    if (VEZ == BRANCA)
                    {
                        if (statusPecas[lold][cocd] == PRETA || statusPecas[lold][cocd] == DAMA_PRETA)
                            return true;
                    }
                    else if (VEZ == PRETA)
                    {
                        if (statusPecas[lold][cocd] == BRANCA || statusPecas[lold][cocd] == DAMA_BRANCA)
                            return true;
                    }
                }
            }
        }
        return false;
    }

    public boolean movimentar(int lo, int co, int ld, int cd)
    {
        int xo = lo;
        int yo = co;
        int xd = ld;
        int yd = cd;

        if (VEZ == BRANCA)
        {
            // Situaes de movimento na dama
            if (statusPecas[xo][yo] == BRANCA)
            {
                if ( (statusPecas[xd][yd] == LIVRE) && ( xo == xd+1)   && 
                     ( yo == yd-1 || yo == yd+1 ) )
                {
                    statusPecas[xo][yo] = LIVRE;
                    statusPecas[xd][yd] = BRANCA;
                    VEZ = PRETA;

                    if (xd == 0)
                    {
                        statusPecas[xd][yd] = DAMA_BRANCA;
                        VEZ = PRETA;
                    }

                    movimentoCompleto = true;
                    return true;
                }
                else if (comerPeca(xo, yo, xd, yd))
                {
                    statusPecas[xo][yo] = LIVRE;
                    statusPecas[xd][yd] = BRANCA;

                    if (pecasPreta == 1)
                    {
                        try 
                        {
                            System.out.println("Jogador com as peas BRANCAS foi vencedor");
                            jogadores[BRANCA].output.writeObject("FIM " + BRANCA);
                            jogadores[PRETA].output.writeObject("FIM " + BRANCA);                        
                        }catch(Exception e){}
                    }
                    else                    
                        pecasPreta--;

                    if (xd == 0)
                    {
                        statusPecas[xd][yd] = DAMA_BRANCA;
                        VEZ = PRETA;
                    }

                    if (!(aindaPodeComer(xd, yd, xd-2, yd-2) || aindaPodeComer(xd, yd, xd-2, yd+2) ||
                          aindaPodeComer(xd, yd, xd+2, yd-2) || aindaPodeComer(xd, yd, xd+2, yd+2)))
                    {
                        VEZ = PRETA;
                        movimentoCompleto = true;
                    }
                    else
                        movimentoCompleto = false;

                    return true;
                 }
            }
            else if (statusPecas[xo][yo] == DAMA_BRANCA)
            {
                if (andarDama(xo, yo, xd, yd))
                {
                    VEZ = PRETA;
                    movimentoCompleto = true;
                }

                if (comerPeca(xo, yo, xd, yd))
                {
                    if (!damaAindaPodeComer(xd, yd, PRETA, DAMA_PRETA))
                    {
                        VEZ = PRETA;
                        movimentoCompleto = true;
                    }
                    else
                        movimentoCompleto = false;
                }

                if (pecasPreta == 0)
                {
                    try
                    {
                        System.out.println("Jogador com as peas BRANCAS foi vencedor");
                        jogadores[BRANCA].output.writeObject("FIM " + BRANCA);
                        jogadores[PRETA].output.writeObject("FIM " + BRANCA);                        
                    }catch(Exception e){}
                }
                return true;
            }
            else return false;
        }
        else
        {
            if (statusPecas[xo][yo] == PRETA)
            {
                if ( (statusPecas[xd][yd] == LIVRE) && (xo == xd-1) &&
                     (yo == yd-1 || yo == yd+1))
                {
                    statusPecas[xo][yo] = LIVRE;
                    statusPecas[xd][yd] = PRETA;
                    VEZ = BRANCA;        
                    
                    if (xd == 7)
                    {
                        statusPecas[xd][yd] = DAMA_PRETA;
                        VEZ = BRANCA;
                    }

                    movimentoCompleto = true;
                    return true;
                }
                else if (comerPeca(xo, yo, xd, yd))
                {
                    statusPecas[xo][yo] = LIVRE;
                    statusPecas[xd][yd] = PRETA;

                    if (pecasBranca == 1)
                    {
                        try
                        {
                            System.out.println("Jogador com as peas PRETAS foi vencedor");
                            jogadores[BRANCA].output.writeObject("FIM " + PRETA);
                            jogadores[PRETA].output.writeObject("FIM " + PRETA);                        
                        } catch(Exception e){}
                    }
                    else                    
                        pecasBranca--;

                    if (xd == 7)
                    {
                        statusPecas[xd][yd] = DAMA_PRETA;
                        VEZ = BRANCA;
                    }

                    if (!(aindaPodeComer(xd, yd, xd-2, yd-2) || aindaPodeComer(xd, yd, xd-2, yd+2) ||
                          aindaPodeComer(xd, yd, xd+2, yd-2) || aindaPodeComer(xd, yd, xd+2, yd+2)))
                    {
                        VEZ = BRANCA;
                        movimentoCompleto = true;
                    }
                    else
                        movimentoCompleto = false;

                    return true;
                }
            }
            else if (statusPecas[xo][yo] == DAMA_PRETA)
            {
                if (andarDama(xo, yo, xd, yd))
                {
                    VEZ = BRANCA;
                    movimentoCompleto = true;
                }

                if (comerPeca(xo, yo, xd, yd))
                {
                    if (!damaAindaPodeComer(xd, yd, BRANCA, DAMA_BRANCA))
                    {
                        VEZ = BRANCA;
                        movimentoCompleto = true;
                    }
                    else
                        movimentoCompleto = false;
                }

                if (pecasBranca == 0)
                {
                    try 
                    {
                        System.out.println("Jogador com as peas PRETAS foi vencedor");
                        jogadores[BRANCA].output.writeObject("FIM " + PRETA);
                        jogadores[PRETA].output.writeObject("FIM " + PRETA);                        
                    } catch(Exception e){}
                }

                return true;
            }
            else return false;
        }

        return false;
    }

    private boolean andarDama(int lo, int co, int ld, int cd)
    {
        if (statusPecas[ld][cd] == LIVRE)
        {
            if (espacoLivre(lo, co, ld, cd) == null)
            {
                if (VEZ == BRANCA)
                {
                    statusPecas[ld][cd] = DAMA_BRANCA;
                    statusPecas[lo][co] = LIVRE;
                }
                else
                {
                    statusPecas[ld][cd] = DAMA_PRETA;
                    statusPecas[lo][co] = LIVRE;
                }
                return true;
            }
        }
        
        return false;
    }

    private Point espacoLivre(int lo, int co, int ld, int cd)
    {
        int x, y;
        x = lo; y = co;

        if (lo == ld && co == cd)
            return null;
        
        if (lo >= 0 && lo < 8 && co >= 0 && co < 8 &&
            ld >= 0 && ld < 8 && cd >= 0 && cd < 8)
        {
            if (co < cd)
            {
                if (lo > ld)
                {
                    do
                    {
                        x--; 
                        y++;
                    } while (statusPecas[x][y] == LIVRE && x != ld && y != cd);
                }
                else
                {
                    do
                    {
                        x++; 
                        y++;
                    } while (statusPecas[x][y] == LIVRE && x != ld && y != cd);
                }
            }
            else
            {
                if (lo > ld)
                {
                    do
                    {
                        x--; 
                        y--;
                    } while (statusPecas[x][y] == LIVRE && x != ld && y != cd);
                }
                else
                {
                    do
                    {
                        x++; 
                        y--;
                    } while (statusPecas[x][y] == LIVRE && x != ld && y != cd);
                }
            }
            
            if (x == ld && y == cd)
                return null;

            return (new Point(x,y));
        }
        // Apenas um cdigo de erro
        return (new Point(0,0));
    }

    private void setEstadoInicial()
    {
        for(int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (i % 2 == 0)
                {
                    if (j % 2 == 1)
                        statusPecas[i][j] = LIVRE;
                    else
                        statusPecas[i][j] = INUTIL;
                }
                else
                {
                    if (j % 2 == 0)
                        statusPecas[i][j] = LIVRE;
                    else
                        statusPecas[i][j] = INUTIL;
                }
            }
        }
        
        // Colocando as peas pretas
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (i % 2 == 0)
                {
                    if (j % 2 == 1)
                        statusPecas[i][j] = PRETA;
                }
                else
                {
                    if (j % 2 == 0)
                        statusPecas[i][j] = PRETA;
                }
            }
        }

        for (int i = 3; i < 5; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (i % 2 == 0)
                {
                    if (j % 2 == 1)
                        statusPecas[i][j] = LIVRE;
                }
                else
                {
                    if (j % 2 == 0)
                        statusPecas[i][j] = LIVRE;
                }
            }
        }
        
        for (int i = 5; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (i % 2 == 0)
                {
                    if (j % 2 == 1)
                        statusPecas[i][j] = BRANCA;
                }
                else
                {
                    if (j % 2 == 0)
                        statusPecas[i][j] = BRANCA;
                }
            }
        }
    }

    private void imprimirMatrizStatus()
    {
        for (int i = 0; i < 8; i++ )
        {
            for (int j = 0; j < 8; j++)
                System.out.print(statusPecas[i][j] + " ");
            System.out.println();
        }
    }
    
    public void broadcast(int remetente, String msg)
    {
        try 
        {
            if(remetente == BRANCA)
                jogadores[PRETA].output.writeObject("MSG " + msg);
            else
                jogadores[BRANCA].output.writeObject("MSG " + msg);
        }
        catch(Exception e){}
    }

    public void reiniciarJogo()
    {
        System.out.println("Pedido de reincio de JOGO");
        
        try
        {
            VEZ = (int)(Math.random() * 2);
            setEstadoInicial();
            pecasPreta = 12;
            pecasBranca = 12;
            comeu = false;
            movimentoCompleto = false;
            x_tmp = 0;
            y_tmp = 0;
            jogadores[BRANCA].output.writeObject("NOV " + VEZ);
            jogadores[PRETA].output.writeObject("NOV " + VEZ);
        }
        catch (Exception e)
        {
            System.out.println("Erro reiniciando jogo");
        }
    }
}

class Jogador extends Thread 
{
    private Socket connection;
    public ObjectInputStream input;
    public ObjectOutputStream output;
    private DamasServidor control;
    protected boolean suspenso = true;
    public int id;

    public Jogador( Socket s, DamasServidor ds, int num )
    {
        connection = s;
        id = num;
        control = ds;
        
        try 
        {
            input = new ObjectInputStream(connection.getInputStream() );
            output = new ObjectOutputStream(connection.getOutputStream() );
            output.writeObject(id + "");
        }
        catch( IOException e ) 
        {
            e.printStackTrace();
        }
    }

    public void run()
    {
        String s;
        
        try
        {
            try
            {
            	synchronized(this)
                {
                    while(suspenso)
                        wait();
                }
            }
            catch (InterruptedException ine){}
            
            System.out.println("Ouvindo clientes...");
            while (true)
            {
                s = (String)input.readObject();

                if (s.charAt(0) == '0')
                    control.validar(0, s);
                else if (s.charAt(0) == '1')
                    control.validar(1, s);
                else 
                {
                    String flag = s.substring(0,3);
                    
                    if (flag.equals("MSG"))
                    {
                        int remetente = Integer.parseInt(s.substring(4, 5));
                        String msg = s.substring(6, s.length());
                        control.broadcast(remetente, msg);
                    }
                    else
                    {
                        // Iniciando um novo jogo
                        control.reiniciarJogo();
                    }
                }
            }
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
    }
}                                                            
